commit bdf9a46c209c803e0f40c9546733a0ca3d809335
Author: Stanislav Král <stanislav.kral3@gmail.com>
Date:   Wed Mar 31 09:47:06 2021 +0200

    Re #8472 - Renamed `make_csr` method to `create_csr`

diff --git a/proj/services/cryptography.py b/proj/services/cryptography.py
index 78deb7f..42fd2b5 100644
--- a/proj/services/cryptography.py
+++ b/proj/services/cryptography.py
@@ -115,9 +115,9 @@ class CryptographyService:
 
             return self._run_for_output(args, proc_input=bytes(key, encoding="utf-8")).decode()
 
-    def make_csr(self, subject, subject_key, subject_key_pass=""):
+    def create_csr(self, subject, subject_key, subject_key_pass=""):
         """
-        Makes a CSR (Certificate Signing Request)
+        Creates a CSR (Certificate Signing Request)
 
         :param subject: an instance of <Subject> representing the subject to be added to the CSR
         :param subject_key: the private key of the subject to be used to generate the CSR
@@ -188,7 +188,7 @@ class CryptographyService:
         :param days: number of days for which the certificate will be valid
         :return: string containing the generated certificate in PEM format
         """
-        csr = self.make_csr(subject, subject_key, subject_key_pass=subject_key_pass)
+        csr = self.create_csr(subject, subject_key, subject_key_pass=subject_key_pass)
         return self.sign_csr(csr, issuer_pem, issuer_key, issuer_key_pass=issuer_key_pass, extensions=extensions,
                              days=days)
 
diff --git a/proj/tests/services/cryptography/make_csr_test.py b/proj/tests/services/cryptography/make_csr_test.py
index 2f4bf72..9e7a91b 100644
--- a/proj/tests/services/cryptography/make_csr_test.py
+++ b/proj/tests/services/cryptography/make_csr_test.py
@@ -12,7 +12,7 @@ def test_make_csr(service):
     private_key = service.create_private_key()
 
     subject = Subject(common_name="foo", country="CZ")
-    csr = service.make_csr(subject, private_key)
+    csr = service.create_csr(subject, private_key)
 
     assert "Subject: CN = foo, C = CZ" in get_csr_pem(csr)
 
@@ -21,6 +21,6 @@ def test_make_csr_pkey_passphrase(service):
     private_key = service.create_private_key(passphrase="foobar")
 
     subject = Subject(common_name="foo", country="CZ", organization_unit="Mysterious Unit")
-    csr = service.make_csr(subject, private_key, subject_key_pass="foobar")
+    csr = service.create_csr(subject, private_key, subject_key_pass="foobar")
 
     assert "Subject: CN = foo, C = CZ, OU = Mysterious Unit" in get_csr_pem(csr)
diff --git a/proj/tests/services/cryptography/sign_csr_test.py b/proj/tests/services/cryptography/sign_csr_test.py
index 91a5cb0..255fee4 100644
--- a/proj/tests/services/cryptography/sign_csr_test.py
+++ b/proj/tests/services/cryptography/sign_csr_test.py
@@ -18,7 +18,7 @@ def test_sign_csr(service):
 
     # create a private key to be used to make a CSR for the intermediate CA
     inter_key = service.create_private_key()
-    csr = service.make_csr(Subject(common_name="bar", country="CZ"), inter_key)
+    csr = service.create_csr(Subject(common_name="bar", country="CZ"), inter_key)
 
     # sign the created CSR with root CA
     inter_ca = service.sign_csr(csr, root_ca, root_key)
@@ -38,7 +38,7 @@ def test_sign_csr_passphrase(service):
 
     # create a private key to be used to make a CSR for the intermediate CA
     inter_key = service.create_private_key()
-    csr = service.make_csr(Subject(common_name="bar", country="CZ"), inter_key)
+    csr = service.create_csr(Subject(common_name="bar", country="CZ"), inter_key)
 
     # sign the created CSR with root CA and specify root key passphrase
     inter_ca = service.sign_csr(csr, root_ca, root_key, issuer_key_pass=root_key_passphrase)
@@ -70,7 +70,7 @@ def test_sign_csr_extensions(service):
 
     # create a private key to be used to make a CSR for the intermediate CA
     inter_key = service.create_private_key()
-    csr = service.make_csr(Subject(common_name="bar", country="CZ"), inter_key)
+    csr = service.create_csr(Subject(common_name="bar", country="CZ"), inter_key)
 
     # sign the created CSR with root CA and specify root key passphrase and specify extensions (AIA and CA)
     inter_ca = service.sign_csr(csr, root_ca, root_key,