commit 04001f70ff885c372c996dbe3e54a410bf2a0dad
Author: Milan Vacek <vacekm@students.zcu.cz>
Date:   Sat May 8 23:28:11 2021 +0200

    Enhancement #8640 Doplnit manual, zkratky morfologie, rukopisů

diff --git a/application/view/manualContent.php b/application/view/manualContent.php
index c81a141..972a5ba 100644
--- a/application/view/manualContent.php
+++ b/application/view/manualContent.php
@@ -1,3 +1,153 @@
+<h1>Zkratky</h1>
+<h2>Morfologické zkratky</h2>
+<p>Morfologické zkratky se skládají z 12 znaků. Pokud je znak pomlčka, znamená to, že není slovo danou morfologickou kategorii nemá, nebo nebyla zadána. Význam ostatních znaků je k náhlednutí níže.
+<h3>Slovní druh</h3>
+<p>První znak v této zkratce uznačuje slovní druh daného slova a může nabývat následujících hodnot.</p>
+<list>
+<li>N : substantivum </li>
+<li>A : adjektivum </li>
+<li>P : pronomen </li>
+<li>C : numeralie </li>
+<li>V : verbum </li>
+<li>D : adverbium </li>
+<li>R : prepozice </li>
+<li>J : konjunkce </li>
+<li>I : interjekce </li>
+<li>T : partikule </li>
+</list>
+<h3>Pád</h3>
+<p>Následující po slovní druhu je číslo v rozsahu 1 - 7, označující pád.</p>
+<list>
+<li>1 : nominativ </li>
+<li>2 : genitiv </li>
+<li>3 : dativ </li>
+<li>4 : akuzativ </li>
+<li>5 : vokativ </li>
+<li>6 : lokál </li>
+<li>7 : instrumentál </li>
+</list>
+<h3>Číslo</h3>
+<p>Třetí znak zkratky označuje číslo daného slova a může nabývat jedné z následujících hodnot.</p>
+<list>
+<li>S : singulár </li>
+<li>P : plurál </li>
+<li>D: duál </li>
+</list>
+<h3>Rod</h3>
+<p>Za znakem označující číslo se nachází znak označující rod. Tento znak může existovat v jedné z následujících podob.</p>
+<list>
+<li>M : maskulinum, </li>
+<li>F : femininum </li>
+<li>N : neutrum </li>
+</list>
+<h3>Stupeň</h3>
+<p>Znak na pátém místě informuje o stupni daného slova.</p>
+<list>
+<li>1 : 1. stupeň </li>
+<li>2 : 2. stupeň  </li>
+<li>3 : 3. stupeň </li>
+</list>
+
+<h3>Tvar</h3>
+<p>Následující znak určuje zda slovo má tvar a v případě, že ano, tak mu přiřazuje jeden ze seznamu níže. </p>
+<list>
+<li>C : tvar složený </li>
+<li>N : tvar jmenný </li>
+</list>
+<h3>Proměnný parametr</h3>
+<p>Po přeskočeném sedmém parametru, viz poznámka níže, se nachází 8 parametr. Tento parametr mění svůj význam na základě slov´ho druhu.</p>
+<h4>Substantivum </h4>
+<p>Parametr se neudává </p>
+<h4>Adjektivum </h4>
+<p>Parametr se neudává </p>
+<h4>Pronomen</h4>
+<list>
+<li>P : osobní </li>
+<li>S : přivlastňovací </li>
+<li>D : ukazovací </li>
+<li>Q : tázací </li>
+<li>J : vztažná </li>
+<li>Z : neurčitá </li>
+<li>L : vymezovací </li>
+<li>W : záporná </li>
+</list>
+<h4>Numeralie</h4>
+<p>Parametr se neudává </p>
+<h4>Verbum</h4>
+<list>
+<li>F : infinitiv </li>
+<li>D : oznamovací způsob </li>
+<li>I : rozkazovací způsob </li>
+<li>C : podmiňovací způsob </li>
+<li>S : supinum </li>
+<li>E : přechodník přítomný </li>
+<li>M : přechodník minulý </li>
+<li>A : participium perfekta aktiva </li>
+<li>P : participium perfekta pasiva </li>
+</list>
+<h4>Adverbium</h4>
+<p>Parametr se neudává </p>
+<h4>Prepozice</h4>
+<p>Parametr se neudává </p>
+<h4>Konjunkce</h4>
+<li>V : větná </li>
+<li>C : členská </li>
+<li>N : navazovací </li>
+<li>P : spojení s přechodníkem </li>
+<h4>Interjekce</h4>
+<p>Parametr se neudává </p>
+<h4>Partikule</h4>
+<p>Parametr se neudává </p>
+<h3>Osoba</h3>
+<p>Následující série parametrů má nadále význam pouze u sloves, první z této série na pozici 9 určuje osobu.</p>
+<list>
+<li>1 : 1. osoba </li>
+<li>2 : 2. osoba  </li>
+<li>3 : 3. osoba </li>
+</list>
+<h3>Čas</h3>
+<p>Další, v pořadí desátý parametr, určuje čas daného slovesa.</p>
+<list>
+<li>P : přítomný čas </li>
+<li>A : aorist  </li>
+<li>R : préteritum </li>
+<li>I : imperfektum </li>
+<li>H : předminulý čas  </li>
+<li>F : budoucí čas </li>
+</list>
+<h3>Slovesný Rod</h3>
+<p>Předposlední parametr určuje slovesný rod a může nabývat následujících hodnot.</p>
+<list>
+<li>P : pasivum </li>
+<li>A : aktivum  </li>
+</list>
+<h3>Slovesný Vid</h3>
+<p>Poslední parametr, jež je zobrazen odpovídá slovesnému vidu a může nabývat nasledující hodnoty.</p>
+<list>
+<li>P : dokonavé sloveso </li>
+<li>I : nedokonavé sloveso  </li>
+</list>
+<p>Poznámka : 7. znak nemá žádnou informační hodnotu a je zachován je z důvodu kompatibility. </p>
+<h2>Zkratky rukopisů</h2>
+<p>V následující části je k náhlednutí seznam všech rukopisů a zkratky, které je reprezentují.</p>
+<list>
+<li>V : rukopis Vídeňský</li>
+<li>H : zlomky Hanušovy</li>
+<li>Hr : zlomky Hradecké</li>
+<li>C : rukopis Cambridžský</li>
+<li>F : rukopis Františkánský</li>
+<li>O : zlomek Olomoucký</li>
+<li>S : fragment Strahovský</li>
+<li>K : zlomky Klementinsko-Křižovnické</li>
+<li>M : zlomky Mnichovské</li>
+<li>L : rukopis Lobkovický</li>
+<li>P : rukopis Pelclův</li>
+<li>Cr : rukopis Cerronský</li>
+<li>Fs : rukopis Fürstenberský</li>
+<li>Z : rukopis Zebererův</li>
+<li>Js : vydání Pavla Ješína z Bezdězi, Praha 1620</li>
+<li>Pl : básně připsané při Pulkavově kronice v rukopisu Litoměřickém</li>
+</list>
 <h1>Vyhledávání</h1>
 <h2>Základní možnosti</h2>
 <p>Vyhledávání je možné dle libovolných z níže uvedených parametrů. Je možné vybrat jeden nebo více parametrů a vyhledávání zobrazí poze výsledky, jež splňují všechny podmínky. Při vybrání specifických parametrů se zobrazí rozšiřující možnosti pro bližší upřesnění požadavků. U parametrů, které zobrazí tyto rozšiřující možnosti, bude tato skutečnost zdůrazněna níže v této kapitole.</p>
diff --git a/application/view/modals/detailModal.html b/application/view/modals/detailModal.html
index 88ddaa4..1996e59 100644
--- a/application/view/modals/detailModal.html
+++ b/application/view/modals/detailModal.html
@@ -482,6 +482,6 @@
         "e": "přech. přítomný",
         "m": "přech. minulý",
         "A": "part. perf. akt.",
-        "P": "part. perf. akt."
+        "P": "part. perf. pas."
     };
 </script>
\ No newline at end of file